// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tuw_multi_robot_msgs:msg/RoutePrecondition.idl
// generated code does not contain a copyright notice

#ifndef TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTE_PRECONDITION__STRUCT_HPP_
#define TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTE_PRECONDITION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__tuw_multi_robot_msgs__msg__RoutePrecondition __attribute__((deprecated))
#else
# define DEPRECATED__tuw_multi_robot_msgs__msg__RoutePrecondition __declspec(deprecated)
#endif

namespace tuw_multi_robot_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RoutePrecondition_
{
  using Type = RoutePrecondition_<ContainerAllocator>;

  explicit RoutePrecondition_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->robot_id = "";
      this->current_route_segment = 0l;
    }
  }

  explicit RoutePrecondition_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : robot_id(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->robot_id = "";
      this->current_route_segment = 0l;
    }
  }

  // field types and members
  using _robot_id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _robot_id_type robot_id;
  using _current_route_segment_type =
    int32_t;
  _current_route_segment_type current_route_segment;

  // setters for named parameter idiom
  Type & set__robot_id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->robot_id = _arg;
    return *this;
  }
  Type & set__current_route_segment(
    const int32_t & _arg)
  {
    this->current_route_segment = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    tuw_multi_robot_msgs::msg::RoutePrecondition_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_multi_robot_msgs::msg::RoutePrecondition_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_multi_robot_msgs::msg::RoutePrecondition_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_multi_robot_msgs::msg::RoutePrecondition_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_multi_robot_msgs::msg::RoutePrecondition_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_multi_robot_msgs::msg::RoutePrecondition_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_multi_robot_msgs::msg::RoutePrecondition_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_multi_robot_msgs::msg::RoutePrecondition_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_multi_robot_msgs::msg::RoutePrecondition_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_multi_robot_msgs::msg::RoutePrecondition_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_multi_robot_msgs__msg__RoutePrecondition
    std::shared_ptr<tuw_multi_robot_msgs::msg::RoutePrecondition_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_multi_robot_msgs__msg__RoutePrecondition
    std::shared_ptr<tuw_multi_robot_msgs::msg::RoutePrecondition_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RoutePrecondition_ & other) const
  {
    if (this->robot_id != other.robot_id) {
      return false;
    }
    if (this->current_route_segment != other.current_route_segment) {
      return false;
    }
    return true;
  }
  bool operator!=(const RoutePrecondition_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RoutePrecondition_

// alias to use template instance with default allocator
using RoutePrecondition =
  tuw_multi_robot_msgs::msg::RoutePrecondition_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace tuw_multi_robot_msgs

#endif  // TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTE_PRECONDITION__STRUCT_HPP_
