// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from tuw_multi_robot_msgs:msg/Vertex.idl
// generated code does not contain a copyright notice
#include "tuw_multi_robot_msgs/msg/detail/vertex__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `path`
#include "geometry_msgs/msg/detail/point__functions.h"
// Member `successors`
// Member `predecessors`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
tuw_multi_robot_msgs__msg__Vertex__init(tuw_multi_robot_msgs__msg__Vertex * msg)
{
  if (!msg) {
    return false;
  }
  // id
  // valid
  // path
  if (!geometry_msgs__msg__Point__Sequence__init(&msg->path, 0)) {
    tuw_multi_robot_msgs__msg__Vertex__fini(msg);
    return false;
  }
  // weight
  // width
  // successors
  if (!rosidl_runtime_c__uint32__Sequence__init(&msg->successors, 0)) {
    tuw_multi_robot_msgs__msg__Vertex__fini(msg);
    return false;
  }
  // predecessors
  if (!rosidl_runtime_c__uint32__Sequence__init(&msg->predecessors, 0)) {
    tuw_multi_robot_msgs__msg__Vertex__fini(msg);
    return false;
  }
  return true;
}

void
tuw_multi_robot_msgs__msg__Vertex__fini(tuw_multi_robot_msgs__msg__Vertex * msg)
{
  if (!msg) {
    return;
  }
  // id
  // valid
  // path
  geometry_msgs__msg__Point__Sequence__fini(&msg->path);
  // weight
  // width
  // successors
  rosidl_runtime_c__uint32__Sequence__fini(&msg->successors);
  // predecessors
  rosidl_runtime_c__uint32__Sequence__fini(&msg->predecessors);
}

bool
tuw_multi_robot_msgs__msg__Vertex__are_equal(const tuw_multi_robot_msgs__msg__Vertex * lhs, const tuw_multi_robot_msgs__msg__Vertex * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  // valid
  if (lhs->valid != rhs->valid) {
    return false;
  }
  // path
  if (!geometry_msgs__msg__Point__Sequence__are_equal(
      &(lhs->path), &(rhs->path)))
  {
    return false;
  }
  // weight
  if (lhs->weight != rhs->weight) {
    return false;
  }
  // width
  if (lhs->width != rhs->width) {
    return false;
  }
  // successors
  if (!rosidl_runtime_c__uint32__Sequence__are_equal(
      &(lhs->successors), &(rhs->successors)))
  {
    return false;
  }
  // predecessors
  if (!rosidl_runtime_c__uint32__Sequence__are_equal(
      &(lhs->predecessors), &(rhs->predecessors)))
  {
    return false;
  }
  return true;
}

bool
tuw_multi_robot_msgs__msg__Vertex__copy(
  const tuw_multi_robot_msgs__msg__Vertex * input,
  tuw_multi_robot_msgs__msg__Vertex * output)
{
  if (!input || !output) {
    return false;
  }
  // id
  output->id = input->id;
  // valid
  output->valid = input->valid;
  // path
  if (!geometry_msgs__msg__Point__Sequence__copy(
      &(input->path), &(output->path)))
  {
    return false;
  }
  // weight
  output->weight = input->weight;
  // width
  output->width = input->width;
  // successors
  if (!rosidl_runtime_c__uint32__Sequence__copy(
      &(input->successors), &(output->successors)))
  {
    return false;
  }
  // predecessors
  if (!rosidl_runtime_c__uint32__Sequence__copy(
      &(input->predecessors), &(output->predecessors)))
  {
    return false;
  }
  return true;
}

tuw_multi_robot_msgs__msg__Vertex *
tuw_multi_robot_msgs__msg__Vertex__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_multi_robot_msgs__msg__Vertex * msg = (tuw_multi_robot_msgs__msg__Vertex *)allocator.allocate(sizeof(tuw_multi_robot_msgs__msg__Vertex), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(tuw_multi_robot_msgs__msg__Vertex));
  bool success = tuw_multi_robot_msgs__msg__Vertex__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
tuw_multi_robot_msgs__msg__Vertex__destroy(tuw_multi_robot_msgs__msg__Vertex * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    tuw_multi_robot_msgs__msg__Vertex__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
tuw_multi_robot_msgs__msg__Vertex__Sequence__init(tuw_multi_robot_msgs__msg__Vertex__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_multi_robot_msgs__msg__Vertex * data = NULL;

  if (size) {
    data = (tuw_multi_robot_msgs__msg__Vertex *)allocator.zero_allocate(size, sizeof(tuw_multi_robot_msgs__msg__Vertex), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = tuw_multi_robot_msgs__msg__Vertex__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        tuw_multi_robot_msgs__msg__Vertex__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
tuw_multi_robot_msgs__msg__Vertex__Sequence__fini(tuw_multi_robot_msgs__msg__Vertex__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      tuw_multi_robot_msgs__msg__Vertex__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

tuw_multi_robot_msgs__msg__Vertex__Sequence *
tuw_multi_robot_msgs__msg__Vertex__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_multi_robot_msgs__msg__Vertex__Sequence * array = (tuw_multi_robot_msgs__msg__Vertex__Sequence *)allocator.allocate(sizeof(tuw_multi_robot_msgs__msg__Vertex__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = tuw_multi_robot_msgs__msg__Vertex__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
tuw_multi_robot_msgs__msg__Vertex__Sequence__destroy(tuw_multi_robot_msgs__msg__Vertex__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    tuw_multi_robot_msgs__msg__Vertex__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
tuw_multi_robot_msgs__msg__Vertex__Sequence__are_equal(const tuw_multi_robot_msgs__msg__Vertex__Sequence * lhs, const tuw_multi_robot_msgs__msg__Vertex__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!tuw_multi_robot_msgs__msg__Vertex__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
tuw_multi_robot_msgs__msg__Vertex__Sequence__copy(
  const tuw_multi_robot_msgs__msg__Vertex__Sequence * input,
  tuw_multi_robot_msgs__msg__Vertex__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(tuw_multi_robot_msgs__msg__Vertex);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    tuw_multi_robot_msgs__msg__Vertex * data =
      (tuw_multi_robot_msgs__msg__Vertex *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!tuw_multi_robot_msgs__msg__Vertex__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          tuw_multi_robot_msgs__msg__Vertex__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!tuw_multi_robot_msgs__msg__Vertex__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
